{  ७ Turbo Vision 2.0               }
{ 騩 ࠡ   묨 䠩    }
{ 祬 ⠭ 㫨.                          }
{ TLScrollBar  ࠡ뢠 न    }
{  20 000 000 ,   ࠡ  묨 }
{ 䠩.                                         }
{  TLWindow ४ 㭪 StandardScrollBar   }
{  ⠢   TLScrollBar             }
{ }
{                   1993 .                  }

unit LongView;

interface

uses Objects, Drivers, Memory, views;

const
  CLScroller = #6#7#5#7#29;

Type
{ TLPoint}
  TLPoint = object
    X, Y: LongInt;
  end;

{ Rectangle object }
{
  TLRect = object
    A, B: TLPoint;
    procedure Assign(XA, YA, XB, YB: Integer);
    procedure Copy(R: TRect);
    procedure Move(ADX, ADY: Integer);
    procedure Grow(ADX, ADY: Integer);
    procedure Intersect(R: TRect);
    procedure Union(R: TRect);
    function Contains(P: TPoint): Boolean;
    function Equals(R: TRect): Boolean;
    function Empty: Boolean;
  end;
 }
{ TLScrollBar }

  PLScrollBar = ^TLScrollBar;
  TLScrollBar = object(TView)
    Value: LongInt;
    Min: LongInt;
    Max: LongInt;
    PgStep: Integer;
    ArStep: Integer;
    constructor Init(var Bounds: TRect);
    constructor Load(var S: TStream);
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure ScrollDraw; virtual;
    function ScrollStep(Part: Integer): Integer; virtual;
    procedure SetParams(AValue, AMin, AMax: LongInt; APgStep, AArStep: Integer);
    procedure SetRange(AMin, AMax: LongInt);
    procedure SetStep(APgStep, AArStep: Integer);
    procedure SetValue(AValue: LongInt);
    procedure Store(var S: TStream);
  private
    Chars: TScrollChars;
    procedure DrawPos(Pos: Integer);
    function GetPos: Integer;
    function GetSize: Integer;
  end;

{ TLScroller object  }

  PLScroller = ^TLScroller;
  TLScroller = object(TView)
    HScrollBar: PLScrollBar;
    VScrollBar: PLScrollBar;
    Delta: TLPoint;
    Limit: TLPoint;
    constructor Init(var Bounds: TRect; AHScrollBar, AVScrollBar: PLScrollBar);
    constructor Load(var S: TStream);
    procedure ChangeBounds(var Bounds: TRect); virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure ScrollDraw; virtual;
    procedure ScrollTo(X, Y: LongInt);
    procedure SetLimit(X, Y: LongInt);
    procedure SetState(AState: Word; Enable: Boolean); virtual;
    procedure Store(var S: TStream);
  private
    DrawLock: Byte;
    DrawFlag: Boolean;
    procedure CheckDraw;
  end;

{ TLWindow object }

  PLWindow = ^TLWindow;
  TLWindow = object(TWindow)
    function StandardScrollBar(AOptions: Word): PLScrollBar;
  end;

const
  RLScrollBar: TStreamRec = (
     ObjType: 337;
     VmtLink: Ofs(TypeOf(TLScrollBar)^);
     Load:    @TLScrollBar.Load;
     Store:   @TLScrollBar.Store
  );

const
  RLScroller: TStreamRec = (
     ObjType: 338;
     VmtLink: Ofs(TypeOf(TLScroller)^);
     Load:    @TLScroller.Load;
     Store:   @TLScroller.Store
  );

const
  RLWindow: TStreamRec = (
     ObjType: 339;
     VmtLink: Ofs(TypeOf(TLWindow)^);
     Load:    @TLWindow.Load;
     Store:   @TLWindow.Store
  );

Implementation

constructor TLScrollBar.Init(var Bounds: TRect);
const
  VChars: TScrollChars = (#30, #31, #177, #254, #178);
  HChars: TScrollChars = (#17, #16, #177, #254, #178);
begin
  TView.Init(Bounds);
  Value := 0;
  Min := 0;
  Max := 0;
  PgStep := 1;
  ArStep := 1;
  if Size.X = 1 then
  begin
    GrowMode := gfGrowLoX + gfGrowHiX + gfGrowHiY;
    Chars := VChars;
  end else
  begin
    GrowMode := gfGrowLoY + gfGrowHiX + gfGrowHiY;
    Chars := HChars;
  end;
end;

constructor TLScrollBar.Load(var S: TStream);
begin
  TView.Load(S);
  S.Read(Value, SizeOf(LongInt) * 3 + SizeOf(integer) * 2 + SizeOf(TScrollChars));
end;

procedure TLScrollBar.Draw;
begin
  DrawPos(GetPos);
end;

procedure TLScrollBar.DrawPos(Pos: Integer);
var
  S: Integer;
  B: TDrawBuffer;
begin
  S := GetSize - 1;
  MoveChar(B[0], Chars[0], GetColor(2), 1);
  if Max = Min then
    MoveChar(B[1], Chars[4], GetColor(1), S - 1)
  else
  begin
    MoveChar(B[1], Chars[2], GetColor(1), S - 1);
    MoveChar(B[Pos], Chars[3], GetColor(3), 1);
  end;
  MoveChar(B[S], Chars[1], GetColor(2), 1);
  WriteBuf(0, 0, Size.X, Size.Y, B);
end;

function TLScrollBar.GetPalette: PPalette;
const
  P: String[Length(CScrollBar)] = CScrollBar;
begin
  GetPalette := @P;
end;

function TLScrollBar.GetPos: Integer;
var
  R  : longint;
begin
  R := Max - Min;
  if R = 0 then
    GetPos := 1 else
    GetPos := Integer((((Value - Min)*Longint(GetSize - 3) + R shr 1) div R) + 1);
end;

function TLScrollBar.GetSize: Integer;
var
  S: Integer;
begin
  if Size.X = 1 then S := Size.Y else S := Size.X;
  if S < 3 then GetSize := 3 else GetSize := S;
end;

procedure TLScrollBar.HandleEvent(var Event: TEvent);
var
  Tracking: Boolean;
  I1 : LongInt;
  I, P, S, ClickPart: Integer;
  Mouse: TPoint;
  Extent: TRect;

function GetPartCode: Integer;
var
  Mark, Part: Integer;
begin
  Part := -1;
  if Extent.Contains(Mouse) then
  begin
    if Size.X = 1 then Mark := Mouse.Y else Mark := Mouse.X;
    if Mark = P then Part := sbIndicator else
    begin
      if Mark < 1 then Part := sbLeftArrow else
        if Mark < P then Part := sbPageLeft else
          if Mark < S then Part := sbPageRight else
            Part := sbRightArrow;
      if Size.X = 1 then Inc(Part, 4);
    end;
  end;
  GetPartCode := Part;
end;

procedure Clicked;
begin
  Message(Owner, evBroadcast, cmScrollBarClicked, @Self);
end;

begin
  TView.HandleEvent(Event);
  case Event.What of
    evMouseDown:
      begin
        Clicked;
        MakeLocal(Event.Where, Mouse);
        GetExtent(Extent);
        Extent.Grow(1, 1);
        P := GetPos;
        S := GetSize - 1;
        ClickPart := GetPartCode;
        if ClickPart <> sbIndicator then
        begin
          repeat
            MakeLocal(Event.Where, Mouse);
            if GetPartCode = ClickPart then
              SetValue(Value + ScrollStep(ClickPart));
          until not MouseEvent(Event, evMouseAuto);
        end else
        begin
          repeat
            MakeLocal(Event.Where, Mouse);
            Tracking := Extent.Contains(Mouse);
            if Tracking then
            begin
              if Size.X = 1 then I := Mouse.Y else I := Mouse.X;
              if I <= 0 then I := 1;
              if I >= S then I := S - 1;
            end else I := GetPos;
            if I <> P then
            begin
              DrawPos(I);
              P := I;
            end;
          until not MouseEvent(Event, evMouseMove);
          if Tracking and (S > 2) then
          begin
            Dec(S, 2);
            SetValue((((P - 1)*(Max - Min)) + S shr 1) div S + Min);
          end;
        end;
        ClearEvent(Event);
      end;
    evKeyDown:
      if State and sfVisible <> 0 then
      begin
        ClickPart := sbIndicator;
        if Size.Y = 1 then
          case CtrlToArrow(Event.KeyCode) of
            kbLeft: ClickPart := sbLeftArrow;
            kbRight: ClickPart := sbRightArrow;
            kbCtrlLeft: ClickPart := sbPageLeft;
            kbCtrlRight: ClickPart := sbPageRight;
            kbHome: I1 := Min;
            kbEnd: I1 := Max;
          else
            Exit;
          end
        else
          case CtrlToArrow(Event.KeyCode) of
            kbUp: ClickPart := sbUpArrow;
            kbDown: ClickPart := sbDownArrow;
            kbPgUp: ClickPart := sbPageUp;
            kbPgDn: ClickPart := sbPageDown;
            kbCtrlPgUp: I1 := Min;
            kbCtrlPgDn: I1 := Max;
          else
            Exit;
          end;
        Clicked;
        if ClickPart <> sbIndicator then I1 := Value + ScrollStep(ClickPart);
        SetValue(I1);
        ClearEvent(Event);
      end;
  end;
end;

procedure TLScrollBar.ScrollDraw;
begin
  Message(Owner, evBroadcast, cmScrollBarChanged, @Self);
end;

function TLScrollBar.ScrollStep(Part: Integer): Integer;
var
  Step: Integer;
begin
  if Part and 2 = 0 then Step := ArStep else Step := PgStep;
  if Part and 1 = 0 then ScrollStep := -Step else ScrollStep := Step;
end;

procedure TLScrollBar.SetParams(AValue, AMin, AMax: longint;
          APgStep, AArStep: Integer);
var
  SValue: longint;
begin
  if AMax < AMin then AMax := AMin;
  if AValue < AMin then AValue := AMin;
  if AValue > AMax then AValue := AMax;
  SValue := Value;
  if (SValue <> AValue) or (Min <> AMin) or (Max <> AMax) then
  begin
    Value := AValue;
    Min := AMin;
    Max := AMax;
    DrawView;
    if SValue <> AValue then ScrollDraw;
  end;
  PgStep := APgStep;
  ArStep := AArStep;
end;

procedure TLScrollBar.SetRange(AMin, AMax: longint);
begin
  SetParams(Value, AMin, AMax, PgStep, ArStep);
end;

procedure TLScrollBar.SetStep(APgStep, AArStep: Integer);
begin
  SetParams(Value, Min, Max, APgStep, AArStep);
end;

procedure TLScrollBar.SetValue(AValue: longint);
begin
  SetParams(AValue, Min, Max, PgStep, ArStep);
end;

procedure TLScrollBar.Store(var S: TStream);
begin
  TView.Store(S);
  S.Write(Value, SizeOf(longint) * 3 + SizeOf(Integer) * 2 + SizeOf(TScrollChars));
end;

{ TLScroller object  }

constructor TLScroller.Init(var Bounds: TRect; AHScrollBar,
  AVScrollBar: PLScrollBar);
begin
  TView.Init(Bounds);
  Options := Options or ofSelectable;
  EventMask := EventMask or evBroadcast;
  HScrollBar := AHScrollBar;
  VScrollBar := AVScrollBar;
end;

constructor TLScroller.Load(var S: TStream);
begin
  TView.Load(S);
  GetPeerViewPtr(S, HScrollBar);
  GetPeerViewPtr(S, VScrollBar);
  S.Read(Delta, SizeOf(TLPoint)*2);
end;

procedure TLScroller.ChangeBounds(var Bounds: TRect);
begin
  SetBounds(Bounds);
  Inc(DrawLock);
  SetLimit(Limit.X, Limit.Y);
  Dec(DrawLock);
  DrawFlag := False;
  DrawView;
end;

procedure TLScroller.CheckDraw;
begin
  if (DrawLock = 0) and DrawFlag then
  begin
    DrawFlag := False;
    DrawView;
  end;
end;

function TLScroller.GetPalette: PPalette;
const
  P: String[Length(CLScroller)] = CLScroller;
begin
  GetPalette := @P;
end;

procedure TLScroller.HandleEvent(var Event: TEvent);
begin
  TView.HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command = cmScrollBarChanged) and
     ((Event.InfoPtr = HScrollBar) or (Event.InfoPtr = VScrollBar)) then
      ScrollDraw;
end;

procedure TLScroller.ScrollDraw;
var
  D: TLPoint;
begin
  if HScrollBar <> nil then D.X := HScrollBar^.Value
  else D.X := 0;
  if VScrollBar <> nil then D.Y := VScrollBar^.Value
  else D.Y := 0;
  if (D.X <> Delta.X) or (D.Y <> Delta.Y) then
  begin
    SetCursor(Cursor.X + integer(Delta.X - D.X), Cursor.Y + integer(Delta.Y - D.Y));
    Delta := D;
    if DrawLock <> 0 then DrawFlag := True else DrawView;
  end;
end;

procedure TLScroller.ScrollTo(X, Y: LongInt);
begin
  Inc(DrawLock);
  if HScrollBar <> nil then HScrollBar^.SetValue(X);
  if VScrollBar <> nil then VScrollBar^.SetValue(Y);
  Dec(DrawLock);
  CheckDraw;
end;

procedure TLScroller.SetLimit(X, Y: LongInt);
begin
  Limit.X := X;
  Limit.Y := Y;
  Inc(DrawLock);
  if HScrollBar <> nil then
    HScrollBar^.SetParams(HScrollBar^.Value, 0, X - Size.X, Size.X - 1,
      HScrollBar^.ArStep);
  if VScrollBar <> nil then
    VScrollBar^.SetParams(VScrollBar^.Value, 0, Y - Size.Y, Size.Y - 1,
      VScrollBar^.ArStep);
  Dec(DrawLock);
  CheckDraw;
end;

procedure TLScroller.SetState(AState: Word; Enable: Boolean);

procedure ShowSBar(SBar: PLScrollBar);
begin
  if (SBar <> nil) then
    if GetState(sfActive + sfSelected) then SBar^.Show
    else SBar^.Hide;
end;

begin
  TView.SetState(AState, Enable);
  if AState and (sfActive + sfSelected) <> 0 then
  begin
    ShowSBar(HScrollBar);
    ShowSBar(VScrollBar);
  end;
end;

procedure TLScroller.Store(var S: TStream);
begin
  TView.Store(S);
  PutPeerViewPtr(S, HScrollBar);
  PutPeerViewPtr(S, VScrollBar);
  S.Write(Delta, SizeOf(TLPoint)*2);
end;

{----------------------------------------------------------------------------}
function TLWindow.StandardScrollBar(AOptions: Word): PLScrollBar;
var
  R: TRect;
  S: PLScrollBar;
begin
  GetExtent(R);
  if AOptions and sbVertical = 0 then
    R.Assign(R.A.X + 2, R.B.Y-1, R.B.X-2, R.B.Y) else
    R.Assign(R.B.X-1,R.A.Y+1,R.B.X,R.B.Y-1);
  S := New(PLScrollBar, Init(R));
  Insert(S);
  if AOptions and sbHandleKeyboard <> 0 then
    S^.Options := S^.Options or ofPostProcess;
  StandardScrollBar := S;
end;

procedure RegisterLongViews;
begin
  RegisterType(RLScrollBar);
  RegisterType(RLScroller);
  RegisterType(RLWindow);
end;

begin
end.