unit TUR5BTRV;
interface
uses Dos,Objects
{$IFDEF DPMI}
,WinAPI
{$ENDIF}
;

 {---------------------------------------------------------------------------

    pp KBUFLEN -  p . ᫨   㦭,  
   ⥪ p楤p   KBUFLEN  255,  ⮣  ⢥ p
     p p    255  .

  ---------------------------------------------------------------------------}

function BTRV (OP:integer; var POS,DATA; var DATALEN: integer;
         var KBUF; {KBUFLEN : integer;} KEY: integer): integer;

function btrvInstalled : Boolean;

implementation

type
  ADDR32 = record                 {32 bit address}
    OFFSET :  integer;
    SEGMENT : integer;
  end;

  BTR_PARMS = record
    USER_BUF_ADDR : ADDR32;           { data buffer address        }
    USER_BUF_LEN :  integer;          { data buffer length         }
    USER_CUR_ADDR : ADDR32;           { currency block address     }
    USER_FCB_ADDR : ADDR32;           { file control block address }
    USER_FUNCTION : integer;          { Btrieve operation          }
    USER_KEY_ADDR : ADDR32;           { key buffer address         }
    USER_KEY_LENGTH : BYTE;           { key buffer length          }
    USER_KEY_NUMBER : BYTE;           { key number                 }
    USER_STAT_ADDR :  ADDR32;         { return status address      }
    XFACE_ID       :  integer;        { language interface id      }
  end;

  DPMIRegisters =
  record
    drDI : LongInt;
    drSI : LongInt;
    drBP : LongInt;
    drReserved : LongInt;
    drBX : LongInt;
    drDX : LongInt;
    drCX : LongInt;
    drAX : LongInt;
    drFlags : Word;
    drES : Word;
    drDS : Word;
    drFS : Word;
    drGS : Word;
    drIP : Word;
    drCS : Word;
    drSP : Word;
    drSS : Word;
  end;

  Result = record
    AX,BX,CX,DX,BP,SI,DI,DS,ES,FLAGS: integer;
  end;

{$IFDEF DPMI}
  const
    rmStackSize = 1024;

  var
    selCommon,
    segCommon,
    selData,
    segData    : Word;

    rXDATA,
    pXDATA    : ^BTR_PARMS;

    rStack,
    pStack,
    rFCB,
    pFCB,
    pIndex,
    rIndex,
    pStat,
    rStat     : Pointer;

    pBtrvInited : Boolean;
    OldExitProc : Pointer;

  procedure DoneDPMIBTRV;
  begin
    ExitProc := OldExitProc;
    if selCommon<>0 then
      GlobalDosFree( selCommon );
    if selData<>0 then
      GlobalDosFree( selData );
  end;

  function InitDPMIBTRV : Boolean;
    var
      globalDos : Longint;
  begin
    selCommon := 0;
    segCommon := 0;
    selData   := 0;
    segData   := 0;
    pBtrvInited := False;
    OldExitProc := ExitProc;
    ExitProc := @DoneDPMIBTRV;
    InitDPMIBTRV := False;

    { Allocate data buffer }

    globalDOS := GlobalDosAlloc( $FFFF );
    if (globalDOS=0) then
      Exit;
    selData := word(globalDOS);
    segData := word(globalDos shr 16);

    { Allocate common buffer }

    globalDOS := GlobalDosAlloc( SizeOf(BTR_PARMS)+255+255+sizeof(integer)+rmStackSize);
    if (globalDOS=0) then
      Exit;
    selCommon := word(globalDOS);
    segCommon := word(globalDos shr 16);

    rXDATA    := Ptr(segCommon,0);
    pXDATA    := Ptr(selCommon,0);

    rFCB      := Ptr(segCommon,SizeOf(BTR_PARMS)+0);
    pFCB      := Ptr(selCommon,SizeOf(BTR_PARMS)+0);

    pIndex    := Ptr(selCommon,SizeOf(BTR_PARMS)+0+255);
    rIndex    := Ptr(segCommon,SizeOf(BTR_PARMS)+0+255);

    pStat     := Ptr(selCommon,SizeOf(BTR_PARMS)+0+255+255);
    rStat     := Ptr(segCommon,SizeOf(BTR_PARMS)+0+255+255);

    rStack    := Ptr(segCommon,SizeOf(BTR_PARMS)+0+255+255+sizeof(integer));
    pStack    := Ptr(selCommon,SizeOf(BTR_PARMS)+0+255+255+sizeof(integer));

    InitDPMIBTRV := True;
    pBtrvInited := True;
  end;

  procedure GetRealModeIntVector(IntNo : Byte; var Vector : Pointer); Assembler;
  asm
    mov     ax,0200h
    mov     bl,IntNo
    int     31h
    les     di,Vector
    mov     word ptr es:[di],dx
    mov     word ptr es:[di+2],cx
  end;

  procedure RealIntr(IntNo: Byte; var Regs: Registers);
    var
      xRegs : DPMIRegisters;
  begin
    FillChar( xRegs, SizeOf(xRegs), #0);
    with xRegs,Regs do
    begin
      drDI := DI;
      drSI := SI;
      drBP := BP;
      drBX := BX;
      drDX := DX;
      drCX := CX;
      drAX := AX;
      drES := ES;
      drDS := DS;
      drFlags := 0;
      drSP := word(rStack)+rmStackSize-2;
      drSS := word(longint(rStack) shr 16);
    end;
    asm
      xor bx,bx
      xor cx,cx
      mov bl,IntNo
      push ss
      pop  es
      lea di,xRegs
      mov ax,0300h
      int 31h
    end;
    with xRegs,Regs do
    begin
      DI := word(drDI);
      SI := word(drSI);
      BP := word(drBP);
      BX := word(drBX);
      DX := word(drDX);
      CX := word(drCX);
      AX := word(drAX);
      ES := word(drES);
      DS := word(drDS);
      Flags := word(drFlags);
    end;

  end;

{$ENDIF}

function BTRV (OP:integer; var POS,DATA; var DATALEN: integer;
         var KBUF; {KBUFLEN : Integer;} KEY: integer): integer;
const
     KBUFLEN    = 255;
     PASCAL_ID  = $AAAA;             {Pascal language id}
     VAR_ID     = $6176;             {id for variable length records - 'va'}
     BTR_INT		= $7B;
     BTR2_INT		= $2F;
     BTR_OFFSET = $0033;
     MULTI_FUNCTION	= $AB;

{  ProcId is used for communicating with the Multi Tasking Version of         }
{  Btrieve. It contains the process id returned from BMulti and should	      }
{  not be changed once it has been set.                                       }

     ProcId: integer = 0;        { initialize to no process id                }
     MULTI: boolean = false;     { set to true if BMulti is loaded            }
     VSet: boolean = false;      { set to true if we have checked for BMulti  }

var
     STAT: integer;                {Btrieve status code}
     XDATA: BTR_PARMS;				     {Btrieve parameter block}
     REGS: Registers;              {register structure used on interrrupt call}
     DONE: boolean;
{$IFDEF DPMI}
     RealModeBtrv : Pointer;
{$ENDIF}
begin
{$IFNDEF DPMI}
  REGS.AX := $3500 + BTR_INT;
  INTR ($21, REGS);
  if (REGS.BX <> BTR_OFFSET) then        {make sure Btrieve is installed}
    STAT := 20
  else
{$ELSE}
  FillChar(Regs, SizeOf(Regs), #0);
  GetRealModeIntVector(BTR_INT, RealModeBtrv);
  if (word(longint(RealModeBtrv)) <> BTR_OFFSET) or (not pBTRVInited) then
    STAT := 20
  else
{$ENDIF}
	begin
    if (not VSet) then {if we haven't checked for Multi-User version}
    begin
      REGS.AX := $3000;
{$IFNDEF DPMI}
      INTR ($21, REGS);
{$ELSE}
      RealINTR ($21, REGS);
{$ENDIF}
      if ((REGS.AX AND $00FF) >= 3) then
      begin
        VSet := true;
        REGS.AX := MULTI_FUNCTION * 256;
{$IFDEF DPMI}
        RealINTR (BTR2_INT, REGS);
{$ELSE}
        INTR (BTR2_INT, REGS);
{$ENDIF}
        MULTI := ((REGS.AX AND $00FF) = $004D);
      end
      else
		    MULTI := false;
      end;
						    {make normal btrieve call}
{$IFDEF DPMI}
      with pXDATA^ do
      begin
        USER_BUF_ADDR.SEGMENT := segData;
        USER_BUF_ADDR.OFFSET := 0;            {set data buffer address}
        USER_BUF_LEN := DATALEN;
        if (@DATA<>nil) then
          Move (Data, Ptr(selData,0)^, DataLen);

        USER_FCB_ADDR.SEGMENT := segCommon;
        USER_FCB_ADDR.OFFSET := word(longint(rFCB));     {set FCB address}
        if (@POS<>nil) then
          Move (POS, pFCB^, 128);

        USER_CUR_ADDR.SEGMENT := USER_FCB_ADDR.SEGMENT;  {set cur seg}
        USER_CUR_ADDR.OFFSET := USER_FCB_ADDR.OFFSET+38; {set cur ofs}
        USER_FUNCTION := OP;                             {set Btrieve operation code}

        USER_KEY_ADDR.SEGMENT := segCommon;
        USER_KEY_ADDR.OFFSET := word(longint(rIndex));   {set key buffer address}
        USER_KEY_LENGTH := 255;                          {assume its large enough}
        if (@KBUF<>nil) then
          Move (KBUF,pIndex^,byte(KBUFLEN));

        USER_KEY_NUMBER := KEY;                          {set key number}
        USER_STAT_ADDR.SEGMENT := segCommon;
        USER_STAT_ADDR.OFFSET := word(longint(rStat));   {set status address}
        XFACE_ID := VAR_ID;                              {set lamguage id}
      end;
      REGS.DX := 0;
      REGS.DS := segCommon;
{$ELSE}
      with XDATA do
      begin
        USER_BUF_ADDR.SEGMENT := SEG (DATA);
        USER_BUF_ADDR.OFFSET := OFS (DATA); {set data buffer address}
        USER_BUF_LEN := DATALEN;
        USER_FCB_ADDR.SEGMENT := SEG (POS);
        USER_FCB_ADDR.OFFSET := OFS (POS);      {set FCB address}
        USER_CUR_ADDR.SEGMENT := USER_FCB_ADDR.SEGMENT; {set cur seg}
        USER_CUR_ADDR.OFFSET := USER_FCB_ADDR.OFFSET+38;{set cur ofs}
        USER_FUNCTION := OP;     {set Btrieve operation code}
        USER_KEY_ADDR.SEGMENT := SEG (KBUF);
        USER_KEY_ADDR.OFFSET := OFS (KBUF);  {set key buffer address}
        USER_KEY_LENGTH := 255;       {assume its large enough}
        USER_KEY_NUMBER := KEY;          {set key number}
        USER_STAT_ADDR.SEGMENT := SEG (STAT);
        USER_STAT_ADDR.OFFSET := OFS (STAT);   {set status address}
        XFACE_ID := VAR_ID;           {set lamguage id}
      end;
      REGS.DX := OFS (XDATA);
      REGS.DS := SEG (XDATA);
{$ENDIF}

      if (NOT MULTI) then         {MultiUser version not installed}
{$IFDEF DPMI}
        RealIntr(BTR_INT, Regs)
{$ELSE}
	      INTR (BTR_INT, REGS)
{$ENDIF}
      else
      begin
        DONE := FALSE;
        repeat
          REGS.BX := ProcId;
          REGS.AX := 1;
          if (REGS.BX <> 0) then
            REGS.AX := 2;
          REGS.AX := REGS.AX + (MULTI_FUNCTION * 256);
{$IFDEF DPMI}
          RealINTR (BTR2_INT, REGS);
{$ELSE}
          INTR (BTR2_INT, REGS);
{$ENDIF}
          if ((REGS.AX AND $00FF) = 0) then
            DONE := TRUE
          else
          begin
            REGS.AX := $0200;
{$IFDEF DPMI}
            RealINTR ($7F, REGS);
{$ELSE}
            INTR ($7F, REGS);
{$ENDIF}
            DONE := FALSE;
          end;
        until (DONE);
        if (ProcId = 0) then
         ProcId := REGS.BX;
      end;
{$IFDEF DPMI}
      STAT := Integer(pStat^);
      if (@DATA<>nil) then
        Move (Ptr(selData,0)^, Data, DataLen);
      DATALEN := pXDATA^.USER_BUF_LEN;
      if (@POS<>nil) then
        Move (pFCB^, POS, 128);
      if (@KBUF<>nil) then
        Move (pIndex^,KBUF,byte(KBUFLEN));
{$ELSE}
      DATALEN := XDATA.USER_BUF_LEN;
{$ENDIF}
	end;
  BTRV := STAT;
end;

function btrvInstalled : Boolean;

  type BTRVVersion = record
      Vesion,
      Revision : Integer;
      OsTag    : Char;
    end;

  var wCode : Word;
      iLength : Integer;
      Version : BTRVVersion;
      dummyKey : String;
begin
  iLength := SizeOf(Version);
  wCode := BTRV(26,dummyKey,Version,iLength,dummyKey,0);
  btrvInstalled := wCode=0;
end;

{$IFDEF DPMI}
begin
  InitDPMIBTRV;
{$ENDIF}
end.
